﻿//////////////////////////////////////////////
// SubEntity.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class BoundingBox ;
	class Entity ;
	class Mesh ;
}

/// Includes ---------------------------------

// nkGraphics
#include "../Dll/DllDefines.h"

// nkExport
#include <NilkinsExport/Exportable/Exportable.h>

/// Class ------------------------------------

namespace nkGraphics
{	
	class DLL_GRAPHICS_EXPORT SubEntity final : public nkExport::Exportable
	{
		private :
		
			// Attributs
			// Mesh associé
			Mesh* _mesh ;
			// Entity parente
			Entity* _parentEntity ;

			// Bounds
			BoundingBox* _bounds ;

			// Témoins
			mutable bool _dirtyNodeTransform ;
		
		public :
		
			// Constructeur, destructeur
			SubEntity () ;
			~SubEntity () ;

			// Getters
			Entity* getParentEntity () const ;
			Mesh* getMesh () const ;
			BoundingBox* getBounds () const ;

			// Setters
			void setParentEntity (Entity* ent) ;
			void setMesh (Mesh* mesh) ;
			void setDirtyNodeTransform (bool value) ;

			// Updates
			void meshUpdatedBounds () ;

			// Import / Export
			virtual void exportClassToTree (nkExport::Node* rootNode) override ;
			virtual void importClassFromTree (nkExport::Node* rootNode) override ;
	} ;
}