﻿//////////////////////////////////////////////
// TextureUtils.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkGraphics
{
	class Texture ;

	enum class TEX_RENDER_FLAG ;
}

/// Includes ---------------------------------

// nkGraphics
#include "../Dll/DllDefines.h"

#include "../Utilities/DxDefinesWrapper.h"

/// Class ------------------------------------

namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT TextureUtils final
	{
		private :

			// Constructeur, destructeur
			TextureUtils () = delete ;
			~TextureUtils () = delete ;

		public :

			// Compute SH
			static void computeIrradianceSH (Texture* input, Texture* output) ;

			// Données sur formats
			static unsigned int getFormatByteSize (FORMAT format) ;
			static unsigned int getFormatChannelCount (FORMAT format) ;
			static FORMAT getFormatSrgbEquivalent (FORMAT format) ;
			static FORMAT getFormatRgbEquivalent (FORMAT format) ;
			static FORMAT getFormatTypelessEquivalent (FORMAT format) ;
			static FORMAT getFormatDepthEquivalent (FORMAT format) ;
			static FORMAT getFormatUncompressedEquivalent (FORMAT format) ;
			static FORMAT getFormatWithAlphaEquivalent (FORMAT format) ;

			static bool isFormatOver255 (FORMAT format) ;
			static bool isFormatCompressed (FORMAT format) ;
			static bool isFormatCompatibleForRenderFlag (FORMAT format, TEX_RENDER_FLAG renderFlag) ;

			// Infos mips
			static int getNeededMipsForSize (int width, int height, int depthOrArraySize) ;
	} ;
}
