﻿//////////////////////////////////////////////
// GlobalTimer.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Includes ---------------------------------

// nkGraphics
#include "../Dll/DllDefines.h"

/// Class ------------------------------------
	
namespace nkGraphics
{
	class DLL_GRAPHICS_EXPORT GlobalTimer
	{
		private :
		
			// Attributs
			// Last time stamps
			unsigned long long _lastFrameTime ;
			unsigned long long _lastDeltaTime ;

			// To customize behaviour
			unsigned long long _currentModuloTime ;
			unsigned long long _modulo ;
			bool _loopedSinceLastTime ;
		
		public :

			// Constructeur, destructeur
			GlobalTimer () ;
			~GlobalTimer () ;

			// Setters
			void setModuloTime (unsigned long long moduloTime) ;
		
			// Le temps depuis la dernière frame
			void updateFrameTime () ;
			unsigned long long getDeltaTime () const ;
			unsigned long long getFrameTime () const ;

			// Pour le modulo
			unsigned long long getCurrentModuloTime () const ;
			unsigned long long getCurrentModulo () const ;
			bool getLoopedSinceLastTime () const ;

			// Getters pour des données actuelles
			int getCurrentYear () ;
			int getCurrentMonth () ;
			int getCurrentDay () ;
			int getCurrentHour () ;
			int getCurrentMin () ;
			int getCurrentSec () ;
	} ;
}