﻿//////////////////////////////////////////////
// Task.h
//
//////////////////////////////////////////////

/// Defines / Macros -------------------------

#pragma once

/// Forward decl -----------------------------

namespace nkTasks
{
	class Thread ;
}

/// Includes ---------------------------------

// nkTasks
#include "../Dll/DllDefines.h"

#include "TaskResult.h"

// Standards
#include <atomic>

/// Class ------------------------------------
	
namespace nkTasks
{
	class DLL_TASKS_EXPORT Task
	{
		private :
		
			// Thread associé, unique
			std::atomic<Thread*> _parentThread ;

			// Le résultat associé
			std::atomic<TASK_RESULT> _workResult ;
			
		public :
		
			// Constructeur, destructeur
			Task () ;
			virtual ~Task () ;

			// Getters
			Thread* getParentThread () const ;
			TASK_RESULT getWorkResult () const ;

			// Setters
			void setParentThread (Thread* thread) ;
			void setWorkResult (TASK_RESULT result) ;

			// Une task aura des callbacks bien définis
			// Tâche appelée en asynchrone
			virtual TASK_RESULT onWork () = 0 ;
			virtual void onWorkDone () = 0 ;
			// Tâches rappelée après, dans le thread appelant
			virtual void onSuccess () = 0 ;
			virtual void onFail () = 0 ;
			virtual void onAbort () = 0 ;			
	} ;
}